/*
 *  The Mana World
 *  Copyright 2004 The Mana World Development Team
 *
 *  This file is part of The Mana World.
 *
 *  The Mana World is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  The Mana World is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with The Mana World; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: buysell.cpp 2128 2006-02-01 12:24:10Z der_doener $
 */

#include "buysell.h"

#include "button.h"

#include "../npc.h"

BuySellDialog::BuySellDialog():
    Window("Shop")
{
    Button *buyButton = 0;
    char *buttonNames[] = {
        "Buy", "Sell", "Cancel", 0
    };
    int x = 10, y = 10;

    for (char **curBtn = buttonNames; *curBtn; curBtn++)
    {
        Button *btn = new Button(*curBtn);
        if (!buyButton) buyButton = btn; // For focus request
        btn->setEventId(*curBtn);
        btn->addActionListener(this);
        btn->setPosition(x, y);
        add(btn);
        x += btn->getWidth() + 10;
    }
    buyButton->requestFocus();

    setContentSize(x, 2 * y + buyButton->getHeight());
    setLocationRelativeTo(getParent());
}

void BuySellDialog::action(const std::string& eventId)
{
    if (eventId == "Buy") {
        current_npc->buy();
    } else if (eventId == "Sell") {
        current_npc->sell();
    } else if (eventId == "Cancel") {
        current_npc = 0;
    }
    setVisible(false);
}
